##################################################################
# Modul für Adam-Ries-Funktionen
#
# VERSION 1
# Letzte Aenderung: 07.11.2009
##################################################################
use POSIX qw /floor ceil/;
use Math::Trig;
use strict;
use warnings;

### Wie viele Stellen vor dem Komma hat eine Zahl.

sub vorkommastellen {
	my ($zahl) = @_;
	my $stellen = 0;

	$zahl = nachkommastellen( $zahl, 0 );

	while ( $zahl >= 1 ) {
		$stellen++;
		$zahl = $zahl / 10;

	}
	if ( $stellen == 0 ) {
		$stellen++;
	}
	else {
		$stellen = $stellen;
	}
	return $stellen;
}

## Hilfsvariablen
my ( $i, $j );
my @rechne       = ();
my @rechnezeilen = ();

## Das Array wird vorbelegt

for ( $i = 0 ; $i <= 1000 ; $i++ ) {
	for ( $j = 0 ; $j <= 1000 ; $j++ ) {
		$rechne[$j][$i] = "";
	}
}

sub schreibezelle {
	my ( $zahl, $zeile, $spalte ) = @_;
	$rechne[$zeile][$spalte] = $zahl;
}

### Das Array wird ausgelesen

sub lesetabellenzeile {
	my ( $zeile, $spalte ) = @_;
	my $i = 0;

	my $text = "";
	my $leer = 0;

	for ( $i = 1 ; $i <= $spalte ; $i++ ) {
		if (   ( $rechne[$zeile][$i] eq "" )
			|| ( $rechne[$zeile][$i] eq " " )
			|| ( $rechne[$zeile][$i] eq "  " ) )
		{
			$leer++;
		}
		if ( $i == $spalte ) {
			$text = $text . $rechne[$zeile][$i] . " \\\\";
		}
		else {
			$text = $text . $rechne[$zeile][$i] . " & ";
		}
	}
	## Ist eine Zeile komplett leer?
	if ( $leer == $spalte ) {
	}
	else {
		ausgabe($text);
	}
}

## Die gegebene Zahl wird in ihre einzelnen Ziffern zerhackt und
## in ein Array geschrieben
sub schreibezahlintabelle {
	my ( $zahl, $exponent, $zeile, $spaltenende ) = @_;

	my $i = 0;
	if ( $exponent >= 0 ) {

		$zahl = $zahl * 10**$exponent;
	}
	else {
		$zahl = $zahl;
	}
	my $wieoftmultipliziere = vorkommastellen($zahl);
	if ( $wieoftmultipliziere <= abs($exponent) ) {
		$wieoftmultipliziere = abs($exponent) + 1;
	}

	if ( $zahl == 0 ) {
		schreibezelle( ($zahl), $zeile, $spaltenende );
	}
	else {
		for ( $i = 0 ; $i < $wieoftmultipliziere ; $i++ ) {
			if ( $exponent < 0 ) {
				if ( ($i) == abs($exponent) ) {
					schreibezelle( ( $zahl % 10 ) . ",", $zeile, $spaltenende - $i );
					$zahl = ( $zahl - ( $zahl % 10 ) ) / 10;
				}
				else {
					schreibezelle( ( $zahl % 10 ), $zeile, $spaltenende - $i );
					$zahl = ( $zahl - ( $zahl % 10 ) ) / 10;
				}
			}
			else {
				schreibezelle( ( $zahl % 10 ), $zeile, $spaltenende - $i );
				$zahl = ( $zahl - ( $zahl % 10 ) ) / 10;
			}
		}
	}
}

## Einen Tabellenkopf und Fuss bauen

sub tabellenkopf {
	my ($anzahlspalten) = @_;

	my ( $spalteninhalt, $i );
	$spalteninhalt = "";
	for ( $i = 0 ; $i <= $anzahlspalten ; $i++ ) {
		$spalteninhalt = $spalteninhalt . "c";
	}
	ausgabe( "\\begin{tabular}{" . $spalteninhalt . "}" );
}

sub tabellenfuss {
	my ($layer) = @_;
	ausgabe("\\end{tabular}");
}

### Einen Tabellenkopf setzen

my $spaltenanzahl = 0;

sub getspaltenanzahl {
	return $spaltenanzahl;
}

sub setspaltenanzahl {
	my ($anzahl) = @_;
	if ( $anzahl >= $spaltenanzahl ) {
		$spaltenanzahl = $anzahl;
	}
	else {
		$spaltenanzahl = $spaltenanzahl;
	}
}

sub zusammensetzen {
	my ( $zeile, $indexstart, $indexende ) = @_;
	my ( $i, $j, $ergebnis );
	$ergebnis = $j = 0;
	if ( $indexende == $indexstart ) {
		$rechne[$zeile][$indexende] =~ tr/,//d;
		return $rechne[$zeile][$indexende];
	}
	else {
		for ( $i = $indexende ; $i >= $indexstart ; $i-- ) {
			$rechne[$zeile][$i] =~ tr/,//d;
			if ( istzahl( $rechne[$zeile][$i] ) == 1 ) {
				$ergebnis = $ergebnis + $rechne[$zeile][$i] * 10**$j;
				$j++;
			}
			else {
				$ergebnis = $ergebnis;
			}
		}
		return $ergebnis;
	}
}

sub teilersein {
	my ( $zahl1, $zahl2 ) = @_;

	if ( ( $zahl1 / $zahl2 ) >= 1 ) {
		return 1;
	}
	else {
		return 0;
	}
}

## Multiplizieren in der Tuermchenschreibweise

sub multipliziere {
	my ( $faktoreins, $faktoreinsexp, $faktorzwei, $faktorzweiexp ) = @_;

	my (
		$stellenfaktoreins,    $stellenfaktorzwei, $stellengesamt,
		$ergebnis,             $zeilen,            $vorzeichenfaktoreins,
		$vorzeichenfaktorzwei, $stellenergebnis,   $faktorzweispeicher
	);

## Haben die Zahlen ein negatives Vorzeichen?
	if ( $faktorzwei < 0 ) {
		$vorzeichenfaktorzwei = 1;
	}
	else {
		$vorzeichenfaktorzwei = 0;
	}
	if ( $faktoreins < 0 ) {
		$vorzeichenfaktoreins = 1;
	}
	else {
		$vorzeichenfaktoreins = 0;
	}

	$faktoreins         = abs($faktoreins);
	$faktorzweispeicher = $faktorzwei = abs($faktorzwei);

## Vor- oder Nachkommastellen?

	if ( $faktoreinsexp >= 0 ) {
		$stellenfaktoreins = vorkommastellen( $faktoreins * 10**$faktoreinsexp );
	}
	else {
		$stellenfaktoreins = vorkommastellen($faktoreins);
		if ( $stellenfaktoreins <= abs($faktoreinsexp) ) {
			$stellenfaktoreins = abs($faktoreinsexp) + 1;
		}
	}
	if ( $faktorzweiexp >= 0 ) {
		$stellenfaktorzwei = vorkommastellen( $faktorzwei * 10**$faktorzweiexp );
	}
	else {

		$stellenfaktorzwei = vorkommastellen($faktorzwei);
		if ( $stellenfaktorzwei <= abs($faktorzweiexp) ) {
			$stellenfaktorzwei = abs($faktorzweiexp) + 1;
		}
	}

	if ( $faktoreinsexp + $faktorzweiexp >= 0 ) {
		$stellenergebnis =
		  vorkommastellen( $faktorzwei * 10**$faktorzweiexp * $faktoreins * 10**$faktoreinsexp );
	}
	else {
		$stellenergebnis = vorkommastellen( $faktorzwei * $faktoreins );
	}

	$stellengesamt =
	  $stellenfaktoreins + 1 + $stellenfaktorzwei + $vorzeichenfaktoreins + $vorzeichenfaktorzwei;

## Die erste Zeile wird geschrieben
## Was ist zu rechnen

	tabellenkopf($stellengesamt);

	if ( $vorzeichenfaktoreins == 1 ) {
		schreibezelle( "\$-\$", 1, 1 );
	}
	schreibezahlintabelle( $faktoreins, $faktoreinsexp, 1,
		$stellenfaktoreins + $vorzeichenfaktoreins );
	schreibezelle( "\$\\cdot\$", 1, $stellenfaktoreins + 1 + $vorzeichenfaktoreins );
	if ( $vorzeichenfaktorzwei == 1 ) {
		schreibezelle( "\$-\$", 1,
			$stellenfaktoreins + 1 + $vorzeichenfaktoreins + $vorzeichenfaktorzwei );
	}

	schreibezahlintabelle( $faktorzwei, $faktorzweiexp, 1,
		$stellenfaktoreins + $vorzeichenfaktoreins + 1 + $stellenfaktorzwei +
		  $vorzeichenfaktorzwei );

	lesetabellenzeile( 1, $stellengesamt );
	ausgabe("\\hline");
	$zeilen = 1;

	my $wieoftmultipliziere = vorkommastellen($faktorzwei);

	my $i = 1;
	my $j = 0;
	for ( $i = 1 + $stellenfaktorzwei ; $i > 1 ; $i-- ) {

		if ( $faktoreinsexp >= 0 ) {
			$ergebnis = $faktoreins * 10**$faktoreinsexp * ( $faktorzwei % 10 );
		}
		else {
			$ergebnis = $faktoreins * ( $faktorzwei % 10 );
		}

		schreibezahlintabelle( $ergebnis, 0, $i, $stellengesamt - $j );
		$faktorzwei = ( $faktorzwei - ( $faktorzwei % 10 ) ) / 10;
		$j++;
		$zeilen++;
	}
	$faktorzwei = $faktorzweispeicher;

	for ( $i = 2 ; $i <= $stellenfaktorzwei + 1 ; $i++ ) {
		lesetabellenzeile( $i, $stellengesamt );
	}

	schreibezahlintabelle(
		$faktoreins * $faktorzwei,
		$faktoreinsexp + $faktorzweiexp,
		$zeilen + 3,
		$stellengesamt
	);

## Der Uebertrag wird bestimmt

	my $uebertrag = 0;
	my $teilsumme = 0;
	for ( $i = $stellengesamt ; $i > 0 ; $i-- ) {
		for ( $j = 2 ; $j <= $zeilen ; $j++ ) {
			if ( $rechne[$j][$i] eq "" ) {
				$teilsumme = $teilsumme;
			}
			else {
				$teilsumme += $rechne[$j][$i];
			}

			$uebertrag = ( $teilsumme - ( $teilsumme % 10 ) ) / 10;

			if ( $uebertrag == 0 ) {
				$rechne[ $zeilen + 1 ][ $i - 1 ] = "";
			}
			else {
				$rechne[ $zeilen + 1 ][ $i - 1 ] = "\\tiny{" . $uebertrag . "}";
			}
			$rechne[ $zeilen + 2 ][$i] = $teilsumme % 10;
		}
		$teilsumme = $uebertrag;
	}

## Das Rechenergebnis wird bestimmt
	lesetabellenzeile( $zeilen + 1, $stellengesamt );

	schreibezahlintabelle(
		$faktoreins * $faktorzwei,
		$faktoreinsexp + $faktorzweiexp,
		$zeilen + 3,
		$stellengesamt
	);
	ausgabe("\\hline \\hline");
	if ( ( $vorzeichenfaktoreins + $vorzeichenfaktorzwei ) == 1 ) {
		schreibezelle( "\$-\$", $zeilen + 3, $stellengesamt - ($stellenergebnis) );
	}
	lesetabellenzeile( $zeilen + 3, $stellengesamt );
	tabellenfuss();
}

### Addition
my $summe;

sub setsumme {
	my ($ergebnis) = @_;
	$summe = $ergebnis;
}

sub setaddition {
	my ($summand) = @_;
	$summe = $summe + $summand;
}

sub getsumme {
	return $summe;
}

## Die Summanden werden eingelesen
sub addiereneinlesen {
	my ( $nummer, $summand, $summandexp ) = @_;

	my $stellensummand;

	if ( $summandexp >= 0 ) {
		$stellensummand = vorkommastellen( $summand * 10**$summandexp );
	}
	else {
		$stellensummand = vorkommastellen($summand);
		if ( $stellensummand <= abs($summandexp) ) {
			$stellensummand = abs($summandexp) + 1;
		}
	}
	setspaltenanzahl( $stellensummand + 1 );
	schreibezahlintabelle( $summand, $summandexp, $nummer, $stellensummand );

	setaddition( $summand * 10**$summandexp );
	setspaltenanzahl( vorkommastellen( getsumme() ) );
}

## Die Rechnungen für die Addtiom finden statt

sub addierenauslesen {
	my ($anzahlzeilen) = @_;
	my ( $j, $i, $speicherzahl );

	for ( $i = 1 ; $i <= $anzahlzeilen ; $i++ ) {
		for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
			$speicherzahl = zusammensetzen( $i, 1, $j );
		}
		for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
			schreibezelle( "", $i, $j );
		}
		schreibezahlintabelle( $speicherzahl, 0, $i, getspaltenanzahl() );

		if ( $i > 1 ) {
			schreibezelle( "\$+\$", $i, 1 );
		}

	}
	my $uebertrag = 0;
	my $teilsumme = 0;
	for ( $i = getspaltenanzahl() ; $i > 0 ; $i-- ) {
		for ( $j = 1 ; $j <= $anzahlzeilen ; $j++ ) {
			if (   ( $rechne[$j][$i] eq "" )
				|| ( $rechne[$j][$i] eq "\$+\$" ) )
			{
				$teilsumme = $teilsumme;

			}
			else {
				$teilsumme += $rechne[$j][$i];
			}

			$uebertrag = ( $teilsumme - ( $teilsumme % 10 ) ) / 10;

			if ( $uebertrag == 0 ) {
				$rechne[ $anzahlzeilen + 1 ][ $i - 1 ] = "";
			}
			else {
				$rechne[ $anzahlzeilen + 1 ][ $i - 1 ] = "\\tiny{" . $uebertrag . "}";
			}
			$rechne[ $anzahlzeilen + 2 ][$i] = $teilsumme % 10;
		}
		$teilsumme = $uebertrag;
	}
	for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
		schreibezelle( "", $anzahlzeilen + 2, $j );
	}
	schreibezahlintabelle( getsumme(), 0, $anzahlzeilen + 2, getspaltenanzahl() );

	for ( $i = 1 ; $i <= $anzahlzeilen + 1 ; $i++ ) {
		lesetabellenzeile( $i, getspaltenanzahl() );
	}

	ausgabe("\\hline \\hline");
	lesetabellenzeile( $anzahlzeilen + 2, getspaltenanzahl() );
}

#### Subtraktion

my $differenz = 0;

sub setdifferenz {
	my ($ergebnis) = @_;
	$differenz = $ergebnis;
}

sub setsubtraktion {
	my ($subtrahend) = @_;
	$differenz = $differenz - $subtrahend;
}

sub getdifferenz {
	return $differenz;
}

sub subtrahiereneinlesen {
	my ( $nummer, $summand, $summandexp ) = @_;

	my ($stellensummand);

	if ( $summandexp >= 0 ) {
		$stellensummand = vorkommastellen( $summand * 10**$summandexp );
	}
	else {
		$stellensummand = vorkommastellen($summand);
		if ( $stellensummand <= abs($summandexp) ) {
			$stellensummand = abs($summandexp) + 1;
		}
	}
	setspaltenanzahl( $stellensummand + 1 );

	schreibezahlintabelle( $summand, $summandexp, $nummer, $stellensummand );
	if ( $nummer > 1 ) {
		setsubtraktion( $summand * 10**$summandexp );
		setaddition( $summand * 10**$summandexp );

	}
	else {
		schreibezahlintabelle( $summand, $summandexp, 0, $stellensummand );
		setsumme(0);
		setdifferenz( $summand * 10**$summandexp );
	}
	setspaltenanzahl( vorkommastellen( getdifferenz() ) );

}

sub subtrahierenauslesen {
	my ($anzahlzeilen) = @_;
	my ( $j, $i, $speicherzahl, $uebertrag, $teilsumme, $teildifferenz, $minuend );

	for ( $i = 0 ; $i <= $anzahlzeilen ; $i++ ) {
		for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
			$speicherzahl = zusammensetzen( $i, 1, $j );
		}
		for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
			schreibezelle( "", $i, $j );
		}
		schreibezahlintabelle( $speicherzahl, 0, $i, getspaltenanzahl() );

		if ( $i > 1 ) {
			schreibezelle( "\$-\$", $i, 1 );
		}
	}
	for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
		schreibezelle( "", $anzahlzeilen + 2, $j );
	}

	for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
		schreibezahlintabelle( 0, 0, $anzahlzeilen + 1, $j );
		schreibezahlintabelle( 0, 0, $anzahlzeilen + 3, $j );
		schreibezahlintabelle( 0, 0, $anzahlzeilen + 5, $j );
	}

	schreibezahlintabelle( getsumme(), 0, $anzahlzeilen + 3, getspaltenanzahl() );

	schreibezahlintabelle( getdifferenz(), 0, $anzahlzeilen + 4, getspaltenanzahl() );

	for ( $i = 1 ; $i <= $anzahlzeilen ; $i++ ) {
		lesetabellenzeile( $i, getspaltenanzahl() );
	}

	$uebertrag = $teilsumme = 0;
	for ( $i = getspaltenanzahl() ; $i > 0 ; $i-- ) {
		for ( $j = 2 ; $j <= $anzahlzeilen ; $j++ ) {
			if (   ( $rechne[$j][$i] eq "" )
				|| ( $rechne[$j][$i] eq "\$-\$" ) )
			{
				$teilsumme = $teilsumme;

			}
			else {
				$teilsumme += $rechne[$j][$i];
			}

			$uebertrag = ( $teilsumme - ( $teilsumme % 10 ) ) / 10;

			if ( $uebertrag == 0 ) {
				$rechne[ $anzahlzeilen + 1 ][ $i - 1 ] = 0;
			}
			else {
				$rechne[ $anzahlzeilen + 1 ][ $i - 1 ] = $uebertrag;
			}

			$rechne[ $anzahlzeilen + 2 ][$i] = $teilsumme % 10;
		}

		$teilsumme = $uebertrag;
	}

	$teildifferenz = $minuend = 0;
	for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
		$minuend = zusammensetzen( 0, 1, $j );
	}
	for ( $j = getspaltenanzahl() ; $j > getspaltenanzahl() - vorkommastellen($minuend) ; $j-- ) {
		$teildifferenz = $rechne[0][$j] - $rechne[ $anzahlzeilen + 3 ][$j];
		if ( $teildifferenz >= 0 ) {
			$rechne[ $anzahlzeilen + 5 ][ $j - 1 ] = $rechne[ $anzahlzeilen + 1 ][ $j - 1 ] + 0;
		}
		else {
			$rechne[ $anzahlzeilen + 5 ][ $j - 1 ] = $rechne[ $anzahlzeilen + 1 ][ $j - 1 ] + 1;
		}
	}

	for ( $j = 1 ; $j <= getspaltenanzahl() ; $j++ ) {
		if ( $rechne[ $anzahlzeilen + 5 ][$j] == 0 ) {
			$rechne[ $anzahlzeilen + 5 ][$j] = "";
		}
		else {
			$rechne[ $anzahlzeilen + 5 ][$j] = "\\tiny{" . $rechne[ $anzahlzeilen + 5 ][$j] . "}";
		}
	}

	lesetabellenzeile( $anzahlzeilen + 5, getspaltenanzahl() );
	ausgabe("\\hline \\hline");
	lesetabellenzeile( $anzahlzeilen + 4, getspaltenanzahl() );
}

### Division

sub dividiere {
	my ( $dividend, $dividendexp, $divisor, $divisorexp ) = @_;

	my (
		$stellendividend, $stellendivisor,     $stellengesamt,     $ergebnis,
		$zeilen,          $vorzeichendividend, $vorzeichendivisor, $stellenergebnis,
		$ende,            $zwischenergebnis,   $i,                 $merkezahl,
		$differenz,       $starte,             $rest,              $reststellen
	);
	if ( $divisorexp < 0 ) {
		$rest =
		  ( ( $dividend * 10**$dividendexp * 10**( -$divisorexp ) ) %
			  ( $divisor * 10**$divisorexp * 10**( -$divisorexp ) ) );
	}
	else {
		$rest = ( ( $dividend * 10**$dividendexp ) % ( $divisor * 10**$divisorexp ) );
	}
	if ( $rest != 0 ) {

		$reststellen = vorkommastellen($rest) + 1;

	}
	else {
		$reststellen = 0;
	}

	my @ergebnisvektor = ();
	for ( $i = 0 ; $i <= 100 ; $i++ ) {
		$ergebnisvektor[$i] = "";
	}

## Haben die Zahlen ein negatives Vorzeichen?
	if ( $divisor < 0 ) {
		$vorzeichendivisor = 1;
	}
	else {
		$vorzeichendivisor = 0;
	}
	if ( $dividend < 0 ) {
		$vorzeichendividend = 1;
	}
	else {
		$vorzeichendividend = 0;
	}

	$dividend = abs($dividend);
	$divisor  = abs($divisor);

## Vor- oder Nachkommastellen?

	if ( $dividendexp >= 0 ) {
		$stellendividend = vorkommastellen( $dividend * 10**$dividendexp );
	}
	else {
		$stellendividend = vorkommastellen($dividend);
		if ( $stellendividend <= abs($dividendexp) ) {
			$stellendividend = abs($dividendexp) + 1;
		}
	}
	if ( $divisorexp >= 0 ) {
		$stellendivisor = vorkommastellen( $divisor * 10**$divisorexp );
	}
	else {
		$stellendivisor = vorkommastellen($divisor);
		if ( $stellendivisor <= abs($divisorexp) ) {
			$stellendivisor = abs($divisorexp) + 1;
		}
	}

	if ( $dividendexp - $divisorexp >= 0 ) {
		$stellenergebnis =
		  vorkommastellen( ( $dividend * 10**$dividendexp ) / ( $divisor * 10**$divisorexp ) );
	}
	else {
		$stellenergebnis = vorkommastellen( $dividend / $divisor );
		if ( $stellenergebnis <= abs( $dividendexp - $divisorexp ) ) {
			$stellenergebnis = abs( $dividendexp - $divisorexp ) + 1;
		}
	}

	$stellengesamt =
	  $stellendividend + 1 + $stellendivisor + $vorzeichendividend + $vorzeichendivisor + 1 +
	  $stellenergebnis + $reststellen;

## Der Tabellenkopf wird geschrieben, wie viele Stellen sind vorhanden.

	tabellenkopf($stellengesamt);

## Die erste Zeile wird geschrieben
## Was ist zu rechnen

	if ( $vorzeichendividend == 1 ) {
		schreibezelle( "\$-\$", 1, 1 );
	}
	schreibezahlintabelle( $dividend, $dividendexp, 1, $stellendividend + $vorzeichendividend );
	## fuer Zwischenrechnungen
	for ( $i = 0 ; $i < 100 ; $i++ ) {
		schreibezahlintabelle( 0, 0, 0, $i );
	}
	schreibezahlintabelle( $dividend, $dividendexp, 0, $stellendividend + $vorzeichendividend );
	schreibezelle( "\$:\$", 1, $stellendividend + 1 + $vorzeichendividend );
	if ( $vorzeichendivisor == 1 ) {
		schreibezelle( "\$-\$", 1,
			$stellendividend + 1 + $vorzeichendividend + $vorzeichendivisor );
	}

	schreibezahlintabelle( $divisor, $divisorexp, 1,
		$stellendividend + $vorzeichendividend + 1 + $stellendivisor + $vorzeichendivisor );

	schreibezelle( "\$=\$", 1,
		$stellendividend + 1 + $vorzeichendividend + $vorzeichendivisor + $stellendivisor + 1 );

	schreibezahlintabelle(
		$dividend / $divisor,
		$dividendexp - $divisorexp,
		1, $stellengesamt - $reststellen
	);

	if ( $rest != 0 ) {
		schreibezelle( "R", 1, $stellengesamt - ( $reststellen - 1 ) );
		schreibezahlintabelle( $rest, 0, 1, $stellengesamt );
	}

	$zeilen = 1;

	lesetabellenzeile( 1, $stellengesamt );

	if ( $dividendexp > 0 ) {
		$dividend = $dividend * 10**$dividendexp;
	}

	if ( $divisorexp > 0 ) {
		$divisor = $divisor * 10**$divisorexp;
	}

	if ( $divisorexp < 0 ) {
		$divisor  = $divisor * 10**( -$divisorexp ) * 10**($divisorexp);
		$dividend = $dividend * 10**( -$divisorexp );
	}

	for ( $i = 0 ; $i < $stellenergebnis ; $i++ ) {
		$ergebnisvektor[ $stellenergebnis - $i ] = zusammensetzen(
			1,
			$stellengesamt - $reststellen - $i,
			$stellengesamt - $reststellen - $i
		);    
	}
	$ende = $differenz = $starte = 0;
	$zeilen++;
	my $anfang = 1;
	my $start  = 1;
	for ( $j = 1 ; $j <= $stellengesamt ; $j++ ) {
		if ( teilersein( zusammensetzen( 0, $anfang, $j ), int( $ergebnisvektor[1] * $divisor ) ) ==
			1 )
		{
			if ( $starte == 0 ) {
				$merkezahl = zusammensetzen( 0, $anfang, $j );
				$starte    = 1;
				$ende      = $j;
			}
		}
	}

	for ( $i = 1 ; $i <= $stellenergebnis ; $i++ ) {
		$zwischenergebnis = int( $ergebnisvektor[$i] * $divisor );

		if ( $ergebnisvektor[$i] != 0 ) {

			$differenz = $merkezahl - $zwischenergebnis;

			for ( $j = 1 ; $j <= $ende ; $j++ ) {
				schreibezahlintabelle( 0, 0, 0, $j );
			}

			schreibezahlintabelle( $differenz, 0, 0, $ende );

			if ( $i > 1 ) {
				schreibezahlintabelle( $merkezahl, 0, $zeilen, $ende );
				lesetabellenzeile( $zeilen, $stellengesamt );
				$zeilen++;
				schreibezahlintabelle( $differenz, 0, 0, $ende );
			}

			if ( $zwischenergebnis != 0 ) {
				schreibezahlintabelle( $zwischenergebnis, 0, $zeilen, $ende );
				lesetabellenzeile( $zeilen, $stellengesamt );
				ausgabe( "\\cline{" . $start . "-" . $ende . "}" );
				$zeilen++;
				schreibezahlintabelle( $differenz, 0, $zeilen, $ende );
			}
		}
		$ende++;
		$merkezahl = zusammensetzen( 0, $anfang, $ende );
		$starte = 0;
		for ( $j = 1 ; $j <= $ende ; $j++ ) {

			if ( zusammensetzen( 0, $j, $j ) == 0 ) {
				if ( $starte == 0 ) {
					$start = $j + 1;
				}
			}
			else {
				$starte = 1;
			}
		}
	}
	$zeilen++;
	$ende = vorkommastellen($dividend);
	schreibezahlintabelle( $rest, 0, $zeilen, $ende );
	lesetabellenzeile( $zeilen, $stellengesamt );
	tabellenfuss();
}

1;
