##################################################################
# Modul für Hilfsfunktionen
#
# VERSION 1
# Letzte Aenderung: 04.11.2009
##################################################################
use POSIX qw /floor ceil/;
use Math::Trig;
use strict;
use warnings;

### Der Funktionswert wird berechnet

sub calcfunk {
	my ( $funktionsausdruck, $variable, $wert ) = @_;

	my $y = $funktionsausdruck;

	$y =~ s/\^/**/g;
	$y =~ s/\b$variable\b/($wert)/g;
	$y = eval($y);

	return $y;

}

## Wie viele Nachkommastellen sollen angegeben werden?

sub nachkommastellen {
	my ( $wert, $nachkommastelle ) = @_;

	my $nachkommastellentext = "%0." . $nachkommastelle . "f";
	if ( $nachkommastelle >= 0 ) {
		$wert = sprintf( $nachkommastellentext, $wert );
	}
	else {
		$wert = $wert;
	}
	return $wert;
}

sub abrunden {
	my ( $wert, $schritt ) = @_;
	return $schritt * floor( $wert / $schritt );
}

sub aufrunden {
	my ( $wert, $schritt ) = @_;
	return $schritt * ceil( $wert / $schritt );
}

### Es wird eine Datei erzeugt

sub latex {
	my ( $layer, $pstrickstext ) = @_;
	schreibeinarray( $layer, sprintf( "%s", $pstrickstext ) );
}

sub ausgabe {
	my ($text) = @_;
	latex( 10, $text );    
}

sub kommentar {
	my (  $text ) = @_;
	schreibeinarray( 10, sprintf( "%%%% %s", $text ) );
}

sub usepackage {
	my ( $parameter, $befehl ) = @_;
	if ( $parameter eq "" ) {
		schreibeinarray( 2, sprintf( "\\usepackage{%s}", $befehl ) );
	}
	else {
		schreibeinarray( 2,
			sprintf( "\\usepackage[%s]{%s}", $parameter, $befehl ) );
	}

}

sub istzahl {
	my ($zeile) = @_;

	if ( $zeile =~ /([0-9\.]+)/ ) {
		return 1;
	}
	else {
		return 0;
	}
}

1;
